// RegExServer.cpp : Implementation of CRegExServer
#include "stdafx.h"
#include "RE_Server.h"
#include "RegExServer.h"


//---- return macros -----------------
#define SEND_TO_POINTER(ptr, retParam) if (ptr != NULL) *ptr = retParam


/////////////////////////////////////////////////////////////////////////////
// CRegExServer


STDMETHODIMP CRegExServer::CompileRE(BSTR BStrRegularExpresion)
{
  _bstr_t bstrRegularExpresion = BStrRegularExpresion;

  m_CompileResult = xmlRegexpCompile((unsigned char*)(char*)bstrRegularExpresion);

	return S_OK;
}

STDMETHODIMP CRegExServer::ExecuteRE(BSTR BStrText, BSTR* pBStrResult)
{
  _bstr_t bstrText = BStrText;

  if( m_CompileResult == NULL )
    return E_FAIL;

  int nRes = xmlRegexpExec(m_CompileResult, (unsigned char*)(char*)bstrText);

  if( nRes < 0 )
    return E_FAIL;
  else if( nRes == 1 )
    SEND_TO_POINTER(pBStrResult, bstrText.copy());

	return S_OK;
}

STDMETHODIMP CRegExServer::Check(BSTR BStrRegularExpresion, BSTR BStrText, VARIANT_BOOL* pbResult)
{
  *pbResult = VARIANT_FALSE;

  _bstr_t bstrRegularExpresion = BStrRegularExpresion;
  CompileRE(bstrRegularExpresion);

  _bstr_t bstrText = BStrText;
  _bstr_t bstrResult;
  HRESULT hResult = ExecuteRE(bstrText, (BSTR*)&bstrResult);

  if( SUCCEEDED(hResult) )
    if( bstrResult == bstrText )
      *pbResult = VARIANT_TRUE;


	return S_OK;
}
