// RegExServer.h : Declaration of the CRegExServer

#ifndef __REGEXSERVER_H_
#define __REGEXSERVER_H_

#include "resource.h"       // main symbols

#include "xmlregexp.h"


/////////////////////////////////////////////////////////////////////////////
// CRegExServer
class ATL_NO_VTABLE CRegExServer : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CRegExServer, &CLSID_RegExServer>,
	public IDispatchImpl<IRegExServer, &IID_IRegExServer, &LIBID_RE_SERVERLib>
{
  xmlRegexp * m_CompileResult;

public:
	CRegExServer()
	{
    m_CompileResult = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_REGEXSERVER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CRegExServer)
	COM_INTERFACE_ENTRY(IRegExServer)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IRegExServer
public:
	STDMETHOD(Check)(/*[in]*/ BSTR BStrRegularExpresion, /*[in]*/ BSTR BStrText, /*[out, retval]*/ VARIANT_BOOL* pbResult);
	STDMETHOD(ExecuteRE)(/*[in]*/ BSTR BStrText, /*[out, retval]*/ BSTR* pBStrResult);
	STDMETHOD(CompileRE)(/*[in]*/ BSTR BStrRegularExpresion);
};

#endif //__REGEXSERVER_H_
