// RE_TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RE_Test.h"
#include "RE_TestDlg.h"

#include "xmlregexp.h"

#define ATLASSERT ASSERT
#include "lrx.h"



#import ".\RE_Server\RE_Server.tlb" named_guids
using namespace RE_SERVERLib;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif





//--- UTF8 convertion ---
inline BSTR UTF8_2_WBSTR(LPCSTR lp, int nLen = -1)
{
  BSTR bSTr = NULL;
  int nConvertedLen = MultiByteToWideChar(CP_UTF8, 0, lp, nLen, NULL, NULL);
  if (nLen == -1)
     nConvertedLen = nConvertedLen - 1;

  bSTr = ::SysAllocStringLen(NULL, nConvertedLen);
  if (bSTr != NULL)
  {
   MultiByteToWideChar(CP_UTF8, 0, lp, -1, bSTr, nConvertedLen);
  }
  return bSTr;
} 

inline BSTR WBSTR_2_UTF8(LPCWSTR lp, int nLen = -1)
{
  BSTR BStr = NULL;
  int nConvertedLen = WideCharToMultiByte(CP_UTF8, 0, lp, nLen, NULL, NULL, NULL, NULL);
  if (nLen == -1)
     nConvertedLen = nConvertedLen - 1;

  BStr = ::SysAllocStringLen(NULL, nConvertedLen);
  if (BStr != NULL)
  {
    WideCharToMultiByte(CP_UTF8, 0, lp, -1, (char*)BStr, nConvertedLen *sizeof(wchar_t), NULL, NULL);
  }
  return BStr;
} 
//-----------------------

/////////////////////////////////////////////////////////////////////////////
// CRE_TestDlg dialog

CRE_TestDlg::CRE_TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRE_TestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRE_TestDlg)
	m_strRegExpr = _T("");
	m_strText = _T("");
	m_strResult = _T("");
	m_strTime = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRE_TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRE_TestDlg)
	DDX_Text(pDX, IDC_EDIT2, m_strRegExpr);
	DDX_Text(pDX, IDC_EDIT1, m_strText);
	DDX_Text(pDX, IDC_EDIT3, m_strResult);
	DDX_Text(pDX, IDC_TIMESTATIC, m_strTime);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRE_TestDlg, CDialog)
	//{{AFX_MSG_MAP(CRE_TestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnLRX_Parce)
	ON_BN_CLICKED(IDC_BUTTON2, OnPCRE_Parce)
	ON_BN_CLICKED(IDC_BUTTON3, OnXmlLibParce)
	ON_BN_CLICKED(IDC_BUTTON_NET, OnButtonNet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRE_TestDlg message handlers

BOOL CRE_TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRE_TestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRE_TestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//======================
// LRX
//======================

void CRE_TestDlg::OnLRX_Parce() 
{
  UpdateData(TRUE); // data is being retrieved 
	//-------------------------
  CAtlRegExp<> reObject;
	SYSTEMTIME startTime, endTime;

	GetLocalTime(&startTime);
	REParseError status = reObject.Parse(_bstr_t(m_strRegExpr));
	if(status != REPARSE_ERROR_OK)
	{
		m_strResult = L"";
		UpdateData(FALSE);
		return;
	}

	CAtlREMatchContext<> mc;
  if( !reObject.Match(_bstr_t(m_strText), &mc) )
  {
    m_strResult = L"";
    UpdateData(FALSE);  //  dialog box is being initialized 
    return; // ERROR!
  }

  wchar_t wchBuff[1024];
  
  swprintf(wchBuff, L"%.*s", mc.m_Match.szEnd -mc.m_Match.szStart, mc.m_Match.szStart);
  m_strResult = CString(L"lrx #") +wchBuff +"#";

//*  if ( mc.m_uNumGroups > 0 )
  for (unsigned int i=0; i<mc.m_uNumGroups; i++ )
  {
    const wchar_t* szStart, * szEnd;
    mc.GetMatch(i, &szStart, &szEnd); //zero based: first group /analog Perl: $1 variable/

    wchar_t wchBuff[1024];
    swprintf(wchBuff, L"%.*s", szEnd -szStart, szStart);

//*    m_strResult = CString(L"#") +wchBuff +"#";
    m_strResult += CString(wchBuff) +"#";
  }
	GetSystemTime(&endTime);
	
	char time[10];
	itoa((endTime.wMilliseconds - startTime.wMilliseconds) + 
		(endTime.wSecond - startTime.wSecond)*1000, time, 10);
	m_strTime = L"Time Parsing:"+(CString)time + L"ms";
  UpdateData(FALSE);  //  dialog box is being initialized 
}


//======================
// PCRE
//======================
//----------------------
#include "pcre.h"

void CRE_TestDlg::OnPCRE_Parce() 
{
	UpdateData(TRUE); // data is being retrieved 
	//-------------------------

	_bstr_t bstrPatern = m_strRegExpr;
	_bstr_t bstrText = m_strText;

	  m_strResult = L"";
  
	SYSTEMTIME startTime, endTime;

	GetLocalTime(&startTime);
	int options = 0;
	const char *error;
	int erroffset;

  // compile regular expression

	pcre* re = pcre_compile ((char*)bstrPatern/*WBSTR_2_UTF8(m_strRegExpr)*/, options, &error, &erroffset, NULL);

	  if ( !re )
	  {
	    UpdateData(FALSE);  //  dialog box is being initialized 
		return;
	  }

	int ovector[30];

	int count = pcre_exec (re, NULL, (char*)bstrText/*WBSTR_2_UTF8(m_strText)*/, bstrText.length(), 0, 0, ovector, 30);
    
	free((void*) re);

	if( count > 0 )
	{
		m_strResult = L"PCRE #";
		for(int i=0; i<count; i++)
		{
		wchar_t* pChBuff;
		char* pCh = (char*)pChBuff;
		int strLen = pcre_get_substring(bstrText, ovector, count, i, (const char **)&pCh);

		m_strResult += CString((pCh)) +L"#";
		pcre_free_substring(pCh);
		}

	}
	GetSystemTime(&endTime);
	
	char time[10];
	itoa((endTime.wMilliseconds - startTime.wMilliseconds) + 
		(endTime.wSecond - startTime.wSecond)*1000, time, 10);
	m_strTime = L"Time Parsing:"+(CString)time + L"ms";//(endTime.wMilliseconds - startTime.wMilliseconds));

	UpdateData(FALSE);  //  dialog box is being initialized 
}


//======================
// xmlLib
//======================



void CRE_TestDlg::OnXmlLibParce() 
{
	SYSTEMTIME startTime, endTime;

	GetLocalTime(&startTime);
	UpdateData();
  m_strResult = L"";

  IRegExServerPtr  spRE_Server;

  CLSID idNewDevice;
  HRESULT hRes = CLSIDFromProgID(_bstr_t("RE_Server.RegExServer.1"), &idNewDevice);
  if (FAILED(hRes))
    return; 

// spRE_Server
  hRes = spRE_Server.CreateInstance(idNewDevice);
  if( FAILED(hRes) )
  {
    UpdateData(FALSE);  //  dialog box is being initialized 
    return; // ERROR!
  }

  spRE_Server->CompileRE(_bstr_t(m_strRegExpr));
  try
  {
	_bstr_t bstrRes = "";
	bstrRes = spRE_Server->ExecuteRE(_bstr_t(m_strText));

	if( bstrRes != _bstr_t(L"") || bstrRes == _bstr_t(L"") && m_strText != _bstr_t(L"") )
		m_strResult = CString("libxml2 #") + (CString)((char*)bstrRes) +(CString)"#";
  }
  catch(...)
  {
	  m_strResult = CString("");
	  return;
  }
    GetSystemTime(&endTime);
	
	char time[10];
	itoa((endTime.wMilliseconds - startTime.wMilliseconds) + 
		(endTime.wSecond - startTime.wSecond)*1000, time, 10);
	m_strTime = L"Time Parsing:"+(CString)time + L"ms";

	UpdateData(false);	
}


//======================
// .NET
//======================



/**/
void CRE_TestDlg::OnButtonNet() 
{
  m_strResult = L"";

  IRegExServerPtr  spRE_Server;
  SYSTEMTIME startTime, endTime;

	GetLocalTime(&startTime);

  CLSID idNewDevice;
  HRESULT hRes = CLSIDFromProgID(_bstr_t("RE_Server.RE_ServerNET"), &idNewDevice);
  if (FAILED(hRes))
    return; 

// spRE_Server
  hRes = spRE_Server.CreateInstance(idNewDevice);
  if( FAILED(hRes) )
  {
    UpdateData(FALSE);  //  dialog box is being initialized 
    return; // ERROR!
  }

	UpdateData();
  spRE_Server->CompileRE(_bstr_t(m_strRegExpr));
  _bstr_t bstrRes = spRE_Server->ExecuteRE(_bstr_t(m_strText));

  m_strResult = CString(L".NET #") + (wchar_t*)bstrRes +L"#";

	GetSystemTime(&endTime);
	
	char time[10];
	itoa((endTime.wMilliseconds - startTime.wMilliseconds) + 
		(endTime.wSecond - startTime.wSecond)*1000, time, 10);
	m_strTime = L"Time Parsing:"+(CString)time + L"ms";
	UpdateData(false);	

}

//{C7CD8A1E-13AA-30C3-A464-EC3F1EBA9D72}
